#
# Conditional build:
%bcond_without	tests		# build with tests

%ifnarch %{x8664}
%undefine	with_tests
%endif
Summary:	The Programmers Solid 3D CAD Modeller
Name:		openscad
Version:	2019.05
Release:	2
# COPYING contains a linking exception for CGAL
# Appdata file is CC0
# Examples are CC0
License:	GPLv2 with exceptions and CC0
Group:		Applications/Engineering
Source0:	http://files.openscad.org/%{name}-%{version}.src.tar.gz
# Source0-md5:	2b63e249d56e2eba62ed5b042e1d82bc
Patch0:		%{name}-polyclipping.patch
Patch1:		localedir.patch
URL:		http://www.openscad.org/
BuildRequires:	Qt5Network-devel
BuildRequires:	Qt5Concurrent-devel
BuildRequires:	Qt5Multimedia-devel
BuildRequires:	Qt5DBus-devel
BuildRequires:	Qt5PrintSupport-devel
BuildRequires:	CGAL-devel >= 3.6
BuildRequires:	ImageMagick
BuildRequires:	Mesa-dri-driver-swrast
BuildRequires:	bison >= 2.4
BuildRequires:	boost-devel >= 1.35
BuildRequires:	desktop-file-utils
BuildRequires:	double-conversion-devel
BuildRequires:	eigen3
BuildRequires:	flex >= 2.5.35
BuildRequires:	fontconfig-devel >= 2.10
BuildRequires:	freetype-devel >= 2.4
BuildRequires:	gettext
BuildRequires:	glew-devel >= 1.6
BuildRequires:	glib2-devel
BuildRequires:	gmp-devel >= 5.0.0
BuildRequires:	harfbuzz-devel >= 0.9.19
BuildRequires:	lib3mf-devel >= 1.8.1
BuildRequires:	libzip-devel
BuildRequires:	libxml2-devel
BuildRequires:	mpfr-devel >= 3.0.0
BuildRequires:	opencsg-devel >= 1.3.2
BuildRequires:	pkgconfig
BuildRequires:	polyclipping-devel >= 6.1.3
BuildRequires:	procps
BuildRequires:	python
BuildRequires:	qscintilla2-qt5-devel >= 2.11.2
BuildRequires:	qt5-build
BuildRequires:	xorg-xserver-Xvfb
Requires:	font(liberationmono)
Requires:	font(liberationsans)
Requires:	font(liberationserif)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

### LICENSES:

##  LGPLv2+:
#   2Dshapes.scad
#   3d_triangle.scad
#   fonts.scad
#   gridbeam.scad
#   hardware.scad
#   libtriangles.scad
#   multiply.scad
#   shapes.scad
#   screw.scad

##  LGPLv2:
#   gears.scad
#   involute_gears.scad
#   servos.scad
#   transformations.scad
#   triangles.scad
#   unregular_shapes.scad
#   bitmap/letter_necklace.scad

##  LGPLv3+:
#   teardrop.scad

##  GPLv3 or LGPLv2:
#   motors.scad
#   nuts_and_bolts.scad


##  GPLv3+ or LGPLv2:
#   metric_fastners.scad
#   regular_shapes.scad

##  CC-BY-SA or LGPLv2+:
#   bearing.scad
#   materials.scad
#   stepper.scad
#   utilities.scad

##  CC-BY-SA or LGPLv2:
#   units.scad

##  CC-BY:
#   polyholes.scad
#   bitmap/alphabet_block.scad
#   bitmap/bitmap.scad
#   bitmap/height_map.scad
#   bitmap/name_tag.scad

## BSD
#   boxes.scad

## MIT
#   constants.scad
#   curves.scad
#   math.scad

## Public Domain
#   lego_compatibility.scad
#   trochoids.scad

###############################################

%description
OpenSCAD is a software for creating solid 3D CAD objects. Unlike most
free software for creating 3D models (such as the famous application
Blender) it does not focus on the artistic aspects of 3D modeling but
instead on the CAD aspects. Thus it might be the application you are
looking for when you are planning to create 3D models of machine parts
but pretty sure is not what you are looking for when you are more
interested in creating computer-animated movies.

%package MCAD
Summary:	OpenSCAD Parametric CAD Library
License:	LGPLv2+ and LGPLv2 and LGPLv3+ and (GPLv3 or LGPLv2) and (GPLv3+ or LGPLv2) and (CC-BY-SA or LGPLv2+) and (CC-BY-SA or LGPLv2) and CC-BY and BSD and MIT and Public Domain
URL:		https://www.github.com/openscad/MCAD
Requires:	%{name} = %{version}-%{release}
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description    MCAD
This library contains components commonly used in designing and
moching up mechanical designs. It is currently unfinished and you can
expect some API changes, however many things are already working.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

# use system package
%{__rm} -r src/ext/polyclipping

%build
qmake-qt5 \
	PREFIX=%{_prefix}
%{__make}

%if %{with tests}
mkdir -p tests/build
cd tests/build
%cmake ../
%{__make}
%{__make} -j1 test
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	INSTALL_ROOT=$RPM_BUILD_ROOT

%{__rm} $RPM_BUILD_ROOT%{_datadir}/%{name}/libraries/MCAD/lgpl-2.1.txt
%{__rm} $RPM_BUILD_ROOT%{_datadir}/%{name}/libraries/MCAD/README.markdown
%{__rm} $RPM_BUILD_ROOT%{_datadir}/%{name}/libraries/MCAD/TODO
%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/%{name}/fonts

%{__mv} $RPM_BUILD_ROOT%{_datadir}/{%{name},}/locale

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc README.md RELEASE_NOTES.md
%attr(755,root,root) %{_bindir}/%{name}
%{_datadir}/metainfo/*.xml
%{_desktopdir}/%{name}.desktop
%{_pixmapsdir}/%{name}.png
%{_datadir}/mime/packages/%{name}.xml
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/examples
%{_datadir}/%{name}/color-schemes
%dir %{_datadir}/%{name}/libraries
%{_mandir}/man1/*

%files MCAD
%defattr(644,root,root,755)
%doc libraries/MCAD/README.markdown libraries/MCAD/TODO
%{_datadir}/%{name}/libraries/MCAD
%changelog
* Wed Oct 09 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/openscad.git;a=log;h=master

* Wed Oct 09 2019 Jan Rękorajski <baggins@pld-linux.org> 102f5f8
- rebuild with boost 1.71
- release 2 (by relup.sh)

* Sun Sep 15 2019 Jan Rękorajski <baggins@pld-linux.org> 40cc174
- leave tests only on x8664, other builders have problems running the suite

* Sun Sep 15 2019 Jan Rękorajski <baggins@pld-linux.org> aff0f9e
- BR double-conversion-devel

* Sun Sep 15 2019 Jan Rękorajski <baggins@pld-linux.org> a451454
- BR qscintilla from a non-broken package

* Sun Sep 15 2019 Jan Rękorajski <baggins@pld-linux.org> 3b02408
- rel 1

* Sun Sep 15 2019 Jan Rękorajski <baggins@pld-linux.org> a7d7666
- up to official release 2019.05
- build with qt5 and drop qt4 support
- updated BRs

* Sat Sep 14 2019 Jan Rękorajski <baggins@pld-linux.org> 7c81224
- does not build with qt4, switch to qt5

* Sat Sep 14 2019 Jan Rękorajski <baggins@pld-linux.org> 9ef2479
- up to 2019.05

* Fri Apr 19 2019 Jan Rękorajski <baggins@pld-linux.org> 35570a7
- up to 2019.01-RC2

* Mon Apr 01 2019 Jan Rękorajski <baggins@pld-linux.org> b00b573
- release 2 (by relup.sh)

* Sun Nov 04 2018 Jan Rękorajski <baggins@pld-linux.org> a126803
- up to 2015.03-3

* Sun Jul 29 2018 Jan Rękorajski <baggins@pld-linux.org> 906ff23
- release 8 (by relup.sh)

* Mon Apr 10 2017 Jan Rękorajski <baggins@pld-linux.org> a08c8e0
- rebuild with boost 1.63.0
- release 7 (by relup.sh)

* Wed May 18 2016 Elan Ruusamäe <glen@delfi.ee> 273faca
- boost 1.61 rebuild
- release 6 (by relup.sh)

* Thu Dec 24 2015 Jan Rękorajski <baggins@pld-linux.org> e3957e7
- release 5 (by relup.sh)

* Sat Nov 21 2015 Jan Rękorajski <baggins@pld-linux.org> b14f2f8
- release 4 (by relup.sh)

* Sun Nov 15 2015 Jan Rękorajski <baggins@pld-linux.org> c4144ae
- release 3 (by relup.sh)

* Mon Jul 13 2015 Jan Rękorajski <baggins@pld-linux.org> cf67235
- release 2 (by relup.sh)

* Sun Jun 14 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 9d3a487
- rel 1; good enough

* Thu Apr 30 2015 Elan Ruusamäe <glen@delfi.ee> 2d0b269
- pldize

